"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPackageSource = exports.clearCache = void 0;
const cacache_1 = __importDefault(require("cacache"));
const util_1 = require("../util");
const local_1 = __importDefault(require("./local"));
const remote_1 = __importDefault(require("./remote"));
async function clearCache() {
    return Promise.all([
        cacache_1.default.rm.all(util_1.BUILD_CACHE),
        local_1.default.clearCache(),
        remote_1.default.clearCache(),
    ]);
}
exports.clearCache = clearCache;
function getPackageSource(source) {
    return source === 'local' ? local_1.default : remote_1.default;
}
exports.getPackageSource = getPackageSource;
